unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, DBGridEhGrouping, ToolCtrlsEh,
  DBGridEhToolCtrls, DynVarsEh, MemTableDataEh, Data.DB, Data.Win.ADODB,
  System.Types,
  MemTableEh, EhLibVCL, GridsEh, DBAxisGridsEh, DBGridEh;

type
  TForm1 = class(TForm)
    DBGridEh1: TDBGridEh;
    MemTableEh1: TMemTableEh;
    DataSource1: TDataSource;
    ADOTable1: TADOTable;
    procedure DBGridEh1Columns0AdvDrawDataCell(Sender: TCustomDBGridEh; Cell,
      AreaCell: TGridCoord; Column: TColumnEh; const ARect: TRect;
      var Params: TColCellParamsEh; var Processed: Boolean);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

type
  TDBGridEhCrack = class(TCustomDBGridEh);

procedure TForm1.DBGridEh1Columns0AdvDrawDataCell(Sender: TCustomDBGridEh; Cell,
  AreaCell: TGridCoord; Column: TColumnEh; const ARect: TRect;
  var Params: TColCellParamsEh; var Processed: Boolean);
var
  Grid: TDBGridEhCrack;
  NextRowIsSpecial: Boolean;
begin
  Grid := TDBGridEhCrack(Sender);
  NextRowIsSpecial := False;

  if (MemTableEh1.FieldByName('SpecialBorderState').AsInteger = 1) then
  begin
    Params.Background := $006DD3EB;
    Params.Font.Style := [fsBold];
  end;

  Grid.DefaultDrawColumnDataCell(Cell, AreaCell, Column, ARect, Params);

  if (AreaCell.Y < Grid.InstantReadRecordCount - 1) then
  begin
    try
      Grid.InstantReadRecordEnter(AreaCell.Y + 1);
      NextRowIsSpecial := MemTableEh1.FieldByName('SpecialBorderState').AsInteger = 1;
    finally
      Grid.InstantReadRecordLeave;
    end;
  end;

  if (MemTableEh1.FieldByName('SpecialBorderState').AsInteger = 1) then
  begin
    Grid.Canvas.Pen.Color := clRed;
    Grid.DrawPolyline(Grid.Canvas, [Point(ARect.Left, ARect.Bottom), Point(ARect.Right, ARect.Bottom)]);
    Grid.DrawPolyline(Grid.Canvas, [Point(ARect.Right, ARect.Top), Point(ARect.Right, ARect.Bottom+1)]);
    if (AreaCell.X = 0) then
      Grid.DrawPolyline(Grid.Canvas, [Point(ARect.Left, ARect.Top), Point(ARect.Left, ARect.Bottom+1)]);
  end else if NextRowIsSpecial then
  begin
    Grid.Canvas.Pen.Color := clRed;
    Grid.DrawPolyline(Grid.Canvas, [Point(ARect.Left, ARect.Bottom), Point(ARect.Right+1, ARect.Bottom)]);
  end;

  Processed := True;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Caption := Caption + ' ' + EhLibVerInfo + ' ' + EhLibBuildInfo;
end;

end.
