unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, MemTableDataEh, Db, DBGridEhGrouping, ADODB, GridsEh, DBGridEh,
  MemTableEh, ToolCtrlsEh, DBGridEhToolCtrls, StdCtrls, Mask, DBCtrlsEh,
  ObjectInspectorEh, SqlTimSt,
  DBLookupEh, DynVarsEh, DBAxisGridsEh, EhLibVCL;

type
  TDBGridEh = class(DBGridEh.TDBGridEh)
  protected
    procedure CheckDrawCellBorder(ACol, ARow: Integer; BorderType: TGridCellBorderTypeEh; var IsDraw: Boolean; var BorderColor: TColor; var IsExtent: Boolean); override;
  end;

  TForm2 = class(TForm)
    MemTableEh1: TMemTableEh;
    DBGridEh1: TDBGridEh;
    DataSource1: TDataSource;
    ADOTable1: TADOTable;
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure DBGridEh1GetCellParams(Sender: TObject; Column: TColumnEh;
      AFont: TFont; var Background: TColor; State: TGridDrawState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation

{$R *.dfm}

procedure TForm2.DBGridEh1GetCellParams(Sender: TObject; Column: TColumnEh;
  AFont: TFont; var Background: TColor; State: TGridDrawState);
begin
  if (MemTableEh1.FieldByName('SpecialBorderState').AsInteger = 1) then
  begin
    Background := $006DD3EB;
    AFont.Style := [fsBold];
  end;
end;

procedure TForm2.FormCreate(Sender: TObject);
begin
  Caption := Caption + ' ' + EhLibVerInfo + ' ' + EhLibBuildInfo;
end;

procedure TForm2.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_F11 then
    ShowObjectInspectorForm(ActiveControl, Rect(Left+Width+10, Top, Left+Width+10+300, Top+Height));
end;

{ TDBGridEh }

procedure TDBGridEh.CheckDrawCellBorder(ACol, ARow: Integer;
  BorderType: TGridCellBorderTypeEh; var IsDraw: Boolean;
  var BorderColor: TColor; var IsExtent: Boolean);
 var
  CellAreaType: TCellAreaTypeEh;
  AreaCol, AreaRow: Integer;
  NextRowIsSpecial: Boolean;
  CurRowIsSpecial: Boolean;
begin
  inherited CheckDrawCellBorder(ACol, ARow, BorderType, IsDraw, BorderColor, IsExtent);

  NextRowIsSpecial := False;
  CellAreaType := GetCellAreaType(ACol, ARow, AreaCol, AreaRow);
  if (CellAreaType.VertType = vctDataEh) then
  begin
    if (AreaRow < InstantReadRecordCount - 1) then
    begin
      try
        InstantReadRecordEnter(AreaRow + 1);
        NextRowIsSpecial := DataSource.DataSet.FieldByName('SpecialBorderState').AsInteger = 1;
      finally
        InstantReadRecordLeave;
      end;
    end;

    try
      InstantReadRecordEnter(AreaRow);
      CurRowIsSpecial := DataSource.DataSet.FieldByName('SpecialBorderState').AsInteger = 1;
    finally
      InstantReadRecordLeave;
    end;


    if (CellAreaType.HorzType = hctDataEh) and
       (BorderType = cbtBottomEh) and
       (NextRowIsSpecial or CurRowIsSpecial) then
    begin
      BorderColor := clRed;
    end else if (BorderType in [cbtLeftEh, cbtRightEh]) and CurRowIsSpecial then
    begin
      BorderColor := clRed;
    end;

  end;
end;

initialization
end.
